


 list p=16F676
 #include<P16F676.inc>
 __CONFIG _CPD_OFF & _CP_OFF & _BODEN_ON & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT


 errorlevel-302
;-------------------------------------------
 #define    _Z		STATUS,Z
 #define	_C		STATUS,C
 #define	bank_0	STATUS,RP0
 #define	bank_1	STATUS,RP0

 #define	DIO_H       PORTC,5     ;
 #define	DIO_tris_H  TRISC,5     ; 
 #define    CLK_H       PORTC,4     ; 

;-------------------------------;

 cblock     0x22
Count
Reg_1
Digit_1
Digit_2
Digit_3
Digit_4
Digit_5
Digit_6
TX_Byte_H
	endc

;
            org     0                                           
            goto    START          
            org    4                                            
            retfie    
;-----------------------------------;
;;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;                                        
START       clrf	INTCON			;   .
            call    0x3FF	        ;   
			bsf  	bank_1			;    1
            movwf   OSCCAL	        ;   
            clrf    WPUA            ; .     
            movlw   b'10000000'     ;
            movwf   OPTION_REG      ;      
			movlw 	b'00001000'	    ;
			movwf 	TRISA 			;  PORTA - 
			movlw   b'00000000'  	
			movwf 	TRISC 			;     
            clrf    ANSEL           ;   
			bcf		bank_0	    	;  0
            movlw	.7              ;
            movwf	CMCON           ;  .
			clrf	PORTA
			clrf	PORTC
;-----------------------------------;
;        22h  7Fh
            movlw   0x22
            movwf   FSR
Load_ad		clrf    INDF
            incf    FSR,f
            movlw   0x60
            subwf   FSR,w
            btfss   _Z
            goto    Load_ad          
            ;-----------------------;
			movlw	.1
			movwf	Digit_1	
			movlw	.2
			movwf	Digit_2		
			movlw	.3
			movwf	Digit_3	
			movlw	.4
			movwf	Digit_4		
			movlw	.5
			movwf	Digit_5	
			movlw	.6
			movwf	Digit_6				
;;
;-------------------------------------------;
;      	 1637           		;
;;
;-------------------------------------------;
Ind_1637_H
            movlw 	0x40          	; ,       
            movwf 	TX_Byte_H       ;    
            call    Start_in_h      ;   
            call  	Byte_Out_h     	;    ,      Byte_Out
            call  	STOP_h    	    ;   

            call    Start_in_h      ;    		
            movlw 	0x8a          	;    0x88...0x8f
            movwf 	TX_Byte_H       ;           
            call  	Byte_Out_h      ;    
            call  	STOP_h    	    ;
;-----------------------------------;  	   
			goto    Indic_1637      ; 
;;
;-----------------------------------;
Byte_Out_h
            movfw 	TX_Byte_H     	;
			movwf   TX_Byte_H	    ;    
			movlw	0x08        	;   8
			movwf	Count	    	;    
Bit_Out_h
			bcf		CLK_H       	;     CLK
            call    Delay_10uS  	;
            bsf     DIO_H       	;
			rrf		TX_Byte_H,f     ;            CLK
			btfss  	_C          	;    
            bcf	    DIO_H       	;  ,    = "0"
            call    Delay_10uS  	; 
			bsf	  	CLK_H       	;    -     
            call    Delay_10uS 		;
			decfsz	Count,f	    	;    
			goto	Bit_Out_h	 	;   
;;
;   
;     
ACK_H         
            bcf     CLK_H       ;   
            ;-------------------;
            bsf     bank_1      ;
            bsf     DIO_tris_H  ;  DIO  
            bcf     bank_0      ;
            ;-------------------;   
Dio_H       btfsc   DIO_H       ; ,      
            goto    Dio_H       ;     
            ;-------------------;
            bsf     bank_1      ;      
            bcf     DIO_tris_H  ;  DIO  
            bcf     bank_0      ;
            ;-------------------;
            bcf     DIO_H       ;      DIO,
            bsf     CLK_H       ;    
            call    Delay_10uS  ; 9    
            bcf     CLK_H       ;                 
				RETURN          ; 
;;
;    
;   
Start_in_h	bsf     DIO_H		;   
            goto    $+1
			bsf     CLK_H       ;   
            call    Delay_10uS  ;
			bcf     DIO_H       ; START -   
                RETURN 
;;
;    
; DIO  CLK  
;  
STOP_h
            call    Delay_10uS  ;
            bsf     CLK_H       ;
            call    Delay_10uS  ;
            bsf     DIO_H       ;
                RETURN
;;
;-------------------------------;
Delay_10uS
            movlw       .2
            movwf       Reg_1
            decfsz      Reg_1,F
            goto        $-1
                RETURN
;-------------------------------;
;; 
Indic_1637 
;    .    
            movlw 	0xC0          	; 
            movwf 	TX_Byte_H       ;    
            call    Start_in_h      ;
            call  	Byte_Out_h     	;    ,     
                                    ;  Byte_Out_h
            movfw  	Digit_1  		;
            call    Table             
            movwf  	TX_Byte_H       ; 
            call  	Byte_Out_h

            movfw  	Digit_2   		; 
            call    Table            
            movwf  	TX_Byte_H       ;
            call  	Byte_Out_h

            movfw  	Digit_3		    ;
            call    Table            
            movwf  	TX_Byte_H       ; 
            call  	Byte_Out_h

            movfw  	Digit_4	        ;
            call    Table             
            movwf  	TX_Byte_H       ; 
            call  	Byte_Out_h

            movfw  	Digit_5		    ; 
            call    Table            
            movwf  	TX_Byte_H       ;
            call  	Byte_Out_h

            movfw  	Digit_6	        ; 
            call    Table            
            movwf  	TX_Byte_H       ;
            call  	Byte_Out_h

            call  	STOP_h    	    ;
			goto	Indic_1637
;;
;    7-  
;      
Table    
         addwf      PCL,f
         retlw      b'00111111'           ; "0" .63
         retlw      b'00000110'           ; "1"
         retlw      b'01011011'           ; "2"
         retlw      b'01001111'           ; "3"
         retlw      b'01100110'           ; "4"
         retlw      b'01101101'           ; "5"
         retlw      b'01111101'           ; "6"
         retlw      b'00000111'           ; "7"
         retlw      b'01111111'           ; "8"
         retlw      b'01101111'           ; "9"
;;

;;
		END
